# Generated by Django 2.0.5 on 2020-04-07 10:57

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [("document", "0042_auto_20200407_0425")]

    def fix_internal_cost_calculation_in_docs_and_templates(apps, schema_editor):
        """
        Update the internal cost calculation in existing docs and templates
        """

        def get_updated_service_cost(
            service_cost_json, engineering_hourly_cost, pm_hourly_cost, after_hours_cost
        ):
            from document.services import DocumentService

            internal_cost_fixed_fee = DocumentService.calculate_fixed_fee_internal_cost(
                service_cost_json,
                engineering_hourly_cost,
                pm_hourly_cost,
                after_hours_cost,
            )
            internal_cost_t_and_m = DocumentService.calculate_t_and_m_internal_cost(
                service_cost_json,
                engineering_hourly_cost,
                pm_hourly_cost,
                after_hours_cost,
            )
            service_cost_json.update(
                {
                    "after_hours_cost": after_hours_cost,
                    "internal_cost_fixed_fee": internal_cost_fixed_fee,
                    "internal_cost_t_and_m_fee": internal_cost_t_and_m,
                }
            )

            return service_cost_json

        SOWDocument = apps.get_model("document", "SOWDocument")
        Provider = apps.get_model("accounts", "Provider")
        SOWTemplate = apps.get_model("document", "SOWTemplate")

        for provider in Provider.objects.all():
            documents = SOWDocument.objects.filter(provider=provider)
            templates = SOWTemplate.objects.filter(provider=provider)

            if documents or templates:
                engineering_hourly_cost = (
                    provider.sow_doc_settings.engineering_hourly_cost
                )
                pm_hourly_cost = provider.sow_doc_settings.pm_hourly_cost
                after_hours_cost = provider.sow_doc_settings.after_hours_cost

            for doc in documents:
                service_cost_json = doc.json_config["service_cost"]
                get_updated_service_cost(
                    service_cost_json,
                    engineering_hourly_cost,
                    pm_hourly_cost,
                    after_hours_cost,
                )
                doc.save()

            for template in templates:
                service_cost_json = template.json_config["service_cost"]
                get_updated_service_cost(
                    service_cost_json,
                    engineering_hourly_cost,
                    pm_hourly_cost,
                    after_hours_cost,
                )
                template.save()

    operations = [migrations.RunPython(fix_internal_cost_calculation_in_docs_and_templates)]
